Adding OVN as an SDN option to Apex
[apex.git] / lib / overcloud-deploy-functions.sh
1 #!/usr/bin/env bash
2 ##############################################################################
3 # Copyright (c) 2015 Tim Rozet (Red Hat), Dan Radez (Red Hat) and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 ##preping it for deployment and launch the deploy
12 ##params: none
13 function overcloud_deploy {
14   local num_compute_nodes
15   local num_control_nodes
16   local dpdk_cores pmd_cores socket_mem ovs_dpdk_perf_flag ovs_option_heat_arr
17   declare -A ovs_option_heat_arr
18
19   ovs_option_heat_arr['dpdk_cores']=OvsDpdkCoreList
20   ovs_option_heat_arr['pmd_cores']=PmdCoreList
21   ovs_option_heat_arr['socket_memory']=OvsDpdkSocketMemory
22
23   # OPNFV Default Environment and Network settings
24   DEPLOY_OPTIONS+=" -e ${ENV_FILE}"
25   DEPLOY_OPTIONS+=" -e network-environment.yaml"
26
27   # Custom Deploy Environment Templates
28   if [[ "${#deploy_options_array[@]}" -eq 0 || "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
29     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
30       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sfc.yaml"
31     elif [ "${deploy_options_array['vpn']}" == 'True' ]; then
32       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-bgpvpn.yaml"
33       if [ "${deploy_options_array['gluon']}" == 'True' ]; then
34         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/services/gluon.yaml"
35       fi
36     elif [ "${deploy_options_array['vpp']}" == 'True' ]; then
37       if [ "${deploy_options_array['sdn_l3']}" == "True" ]; then
38         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb.yaml"
39       else
40         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb-l2.yaml"
41       fi
42     else
43       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-l3.yaml"
44     fi
45     SDN_IMAGE=opendaylight
46   elif [ "${deploy_options_array['sdn_controller']}" == 'opendaylight-external' ]; then
47     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight-external.yaml"
48     SDN_IMAGE=opendaylight
49   elif [ "${deploy_options_array['sdn_controller']}" == 'onos' ]; then
50     echo -e "${red}ERROR: ONOS is unsupported in Danube...exiting${reset}"
51     exit 1
52     #if [ "${deploy_options_array['sfc']}" == 'True' ]; then
53     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos_sfc.yaml"
54     #else
55     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos.yaml"
56     #fi
57     #SDN_IMAGE=onos
58   elif [ "${deploy_options_array['sdn_controller']}" == 'ovn' ]; then
59     if [[ "$ha_enabled" == "True" ]]; then
60       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-ovn-ha.yaml"
61       echo "${red}OVN HA support is not not supported... exiting.${reset}"
62       exit 1
63     else
64       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-ovn.yaml"
65     fi
66     SDN_IMAGE=opendaylight
67   elif [ "${deploy_options_array['sdn_controller']}" == 'opencontrail' ]; then
68     echo -e "${red}ERROR: OpenContrail is currently unsupported...exiting${reset}"
69     exit 1
70   elif [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
71     echo -e "${blue}INFO: SDN Controller disabled...will deploy nosdn scenario${reset}"
72     if [ "${deploy_options_array['vpp']}" == 'True' ]; then
73       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-vpp.yaml"
74     elif [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
75       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ovs-dpdk.yaml"
76     fi
77     SDN_IMAGE=opendaylight
78   else
79     echo "${red}Invalid sdn_controller: ${deploy_options_array['sdn_controller']}${reset}"
80     echo "${red}Valid choices are opendaylight, opendaylight-external, onos, opencontrail, False, or null${reset}"
81     exit 1
82   fi
83
84   # Enable Tacker
85   if [ "${deploy_options_array['tacker']}" == 'True' ]; then
86     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_tacker.yaml"
87   fi
88
89   # Enable Congress
90   if [ "${deploy_options_array['congress']}" == 'True' ]; then
91     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_congress.yaml"
92   fi
93
94   # Enable Real Time Kernel (kvm4nfv)
95   if [ "${deploy_options_array['rt_kvm']}" == 'True' ]; then
96     DEPLOY_OPTIONS+=" -e /home/stack/enable_rt_kvm.yaml"
97   fi
98
99   # Make sure the correct overcloud image is available
100   if [ ! -f $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 ]; then
101       echo "${red} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 is required to execute your deployment."
102       echo "Please install the opnfv-apex package to provide this overcloud image for deployment.${reset}"
103       exit 1
104   fi
105
106   echo "Copying overcloud image to Undercloud"
107   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f overcloud-full.qcow2"
108   scp ${SSH_OPTIONS[@]} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 "stack@$UNDERCLOUD":overcloud-full.qcow2
109
110   # disable neutron openvswitch agent from starting
111   if [[ -n "${deploy_options_array['sdn_controller']}" && "${deploy_options_array['sdn_controller']}" != 'False' ]]; then
112       echo -e "${blue}INFO: Disabling neutron-openvswitch-agent from systemd${reset}"
113       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
114       LIBGUESTFS_BACKEND=direct virt-customize --run-command "rm -f /etc/systemd/system/multi-user.target.wants/neutron-openvswitch-agent.service" \
115                                                --run-command "rm -f /usr/lib/systemd/system/neutron-openvswitch-agent.service" \
116                                                -a overcloud-full.qcow2
117 EOI
118   fi
119
120   if [ "${deploy_options_array['vpn']}" == 'True' ]; then
121       echo -e "${blue}INFO: Enabling ZRPC and Quagga${reset}"
122       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
123       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y install /root/quagga/*.rpm" \
124                                                --run-command "systemctl enable zrpcd" \
125                                                -a overcloud-full.qcow2
126 EOI
127   fi
128
129   # Install ovs-dpdk inside the overcloud image if it is enabled.
130   if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' || "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
131     # install dpdk packages before ovs
132     echo -e "${blue}INFO: Enabling kernel modules for dpdk inside overcloud image${reset}"
133
134     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
135       cat << EOF > vfio_pci.modules
136 #!/bin/bash
137 exec /sbin/modprobe vfio_pci >/dev/null 2>&1
138 EOF
139
140       cat << EOF > uio_pci_generic.modules
141 #!/bin/bash
142 exec /sbin/modprobe uio_pci_generic >/dev/null 2>&1
143 EOF
144
145       LIBGUESTFS_BACKEND=direct virt-customize --upload vfio_pci.modules:/etc/sysconfig/modules/ \
146                                                --upload uio_pci_generic.modules:/etc/sysconfig/modules/ \
147                                                --run-command "chmod 0755 /etc/sysconfig/modules/vfio_pci.modules" \
148                                                --run-command "chmod 0755 /etc/sysconfig/modules/uio_pci_generic.modules" \
149                                                -a overcloud-full.qcow2
150
151       if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
152         sed -i "/OS::TripleO::ComputeExtraConfigPre:/c\  OS::TripleO::ComputeExtraConfigPre: ./ovs-dpdk-preconfig.yaml" network-environment.yaml
153       fi
154
155 EOI
156
157   elif [ "${deploy_options_array['dataplane']}" != 'ovs' ]; then
158     echo "${red}${deploy_options_array['dataplane']} not supported${reset}"
159     exit 1
160   fi
161
162   if [ "$debug" == 'TRUE' ]; then
163     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "LIBGUESTFS_BACKEND=direct virt-customize -a overcloud-full.qcow2 --root-password password:opnfvapex"
164   fi
165
166   # upgrade ovs into ovs 2.5.90 with NSH function if SFC is enabled
167   if [[ "${deploy_options_array['sfc']}" == 'True' && "${deploy_options_array['dataplane']}" == 'ovs' ]]; then
168     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
169          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_kmod_rpm_name}" \
170                                                   --run-command "yum upgrade -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_rpm_name}" \
171                                                   -a overcloud-full.qcow2
172 EOI
173   fi
174
175   # Patch neutron with using OVS external interface for router and add generic linux NS interface driver
176   if [[ "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
177     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
178       LIBGUESTFS_BACKEND=direct virt-customize --run-command "cd /usr/lib/python2.7/site-packages/ && patch -p1 < neutron-patch-NSDriver.patch" \
179                                                -a overcloud-full.qcow2
180 EOI
181     # Configure routing node for odl_l3-fdio
182     if [[ "${deploy_options_array['sdn_l3']}" == 'True' ]]; then
183       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
184         sed -i "/opendaylight::vpp_routing_node:/c\    opendaylight::vpp_routing_node: ${deploy_options_array['odl_vpp_routing_node']}.${domain_name}" ${ENV_FILE}
185 EOI
186     fi
187   fi
188
189   if [ -n "${deploy_options_array['performance']}" ]; then
190     ovs_dpdk_perf_flag="False"
191     for option in "${performance_options[@]}" ; do
192       arr=($option)
193       # use compute's kernel settings for all nodes for now.
194       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "kernel" ]; then
195         kernel_args+=" ${arr[2]}=${arr[3]}"
196       fi
197       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "ovs" ]; then
198          eval "${arr[2]}=${arr[3]}"
199          ovs_dpdk_perf_flag="True"
200       fi
201     done
202
203     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
204       sed -i "/ComputeKernelArgs:/c\  ComputeKernelArgs: '$kernel_args'" ${ENV_FILE}
205       sed -i "$ a\resource_registry:\n  OS::TripleO::NodeUserData: first-boot.yaml" ${ENV_FILE}
206       sed -i "/NovaSchedulerDefaultFilters:/c\  NovaSchedulerDefaultFilters: 'RamFilter,ComputeFilter,AvailabilityZoneFilter,ComputeCapabilitiesFilter,ImagePropertiesFilter,NUMATopologyFilter'" ${ENV_FILE}
207 EOI
208
209     if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' && "$ovs_dpdk_perf_flag" == "True" ]]; then
210       for ovs_option in ${!ovs_option_heat_arr[@]}; do
211         if [ -n "${!ovs_option}" ]; then
212           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
213             sed -i "/${ovs_option_heat_arr[$ovs_option]}:/c\  ${ovs_option_heat_arr[$ovs_option]}: ${!ovs_option}" ${ENV_FILE}
214 EOI
215         fi
216       done
217     fi
218   fi
219
220   if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
221     if [ "${deploy_options_array['dataplane']}" == "fdio" ]; then
222       if [ "$tenant_nic_mapping_controller_members" == "$tenant_nic_mapping_compute_members" ]; then
223         ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
224           sed -i "/NeutronVPPAgentPhysnets:/c\  NeutronVPPAgentPhysnets: 'datacentre:${tenant_nic_mapping_controller_members}'" ${ENV_FILE}
225 EOI
226       else
227         echo -e "${red}Compute and Controller must use the same tenant nic name, please modify network setting file.${reset}"
228         exit 1
229       fi
230     fi
231   fi
232
233   # Set ODL version accordingly
234   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && -n "${deploy_options_array['odl_version']}" ]]; then
235     case "${deploy_options_array['odl_version']}" in
236       beryllium) odl_version=''
237               ;;
238       boron)  odl_version='boron'
239               ;;
240       carbon) odl_version='master'
241               ;;
242       *) echo -e "${red}Invalid ODL version ${deploy_options_array['odl_version']}.  Please use 'carbon' or 'boron' values.${reset}"
243          exit 1
244          ;;
245     esac
246
247     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
248       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
249                                                --run-command "yum -y install /root/${odl_version}/*" \
250                                                -a overcloud-full.qcow2
251 EOI
252   fi
253
254   # Override ODL if FDIO and ODL L2
255   if [[ "${deploy_options_array['vpp']}" == 'True' && "${deploy_options_array['sdn_controller']}" == 'opendaylight' && "${deploy_options_array['sdn_l3']}" == "False" ]]; then
256     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
257          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
258                                                   --run-command "yum -y install /root/fdio_l2/opendaylight*.rpm" \
259                                                   -a overcloud-full.qcow2
260 EOI
261   fi
262
263   # check if ceph should be enabled
264   if [ "${deploy_options_array['ceph']}" == 'True' ]; then
265     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/storage-environment.yaml"
266   fi
267
268   if [ "${deploy_options_array['sdn_controller']}" == 'ovn' ]; then
269     # The epoch in deloran's ovs is 1: and in leif's is 0:
270     # so we have to execute a downgrade instead of an update
271     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
272       LIBGUESTFS_BACKEND=direct virt-customize \
273         --run-command "cd /root/ovs27 && yum update -y *openvswitch*" \
274         --run-command "cd /root/ovs27 && yum downgrade -y *openvswitch*" \
275         -a overcloud-full.qcow2
276 EOI
277   fi
278
279   # get number of nodes available in inventory
280   num_control_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:control /home/stack/instackenv.json")
281   num_compute_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:compute /home/stack/instackenv.json")
282
283   # check if HA is enabled
284   if [[ "$ha_enabled" == "True" ]]; then
285     if [ "$num_control_nodes" -lt 3 ]; then
286       echo -e "${red}ERROR: Number of control nodes in inventory is less than 3 and HA is enabled: ${num_control_nodes}. Check your inventory file.${reset}"
287       exit 1
288     else
289      DEPLOY_OPTIONS+=" --control-scale ${num_control_nodes}"
290      DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/puppet-pacemaker.yaml"
291      echo -e "${blue}INFO: Number of control nodes set for deployment: ${num_control_nodes}${reset}"
292     fi
293   else
294     if [ "$num_control_nodes" -lt 1 ]; then
295       echo -e "${red}ERROR: Number of control nodes in inventory is less than 1: ${num_control_nodes}. Check your inventory file.${reset}"
296       exit 1
297     fi
298   fi
299
300   if [ "$num_compute_nodes" -le 0 ]; then
301     echo -e "${red}ERROR: Invalid number of compute nodes: ${num_compute_nodes}. Check your inventory file.${reset}"
302     exit 1
303   else
304     echo -e "${blue}INFO: Number of compute nodes set for deployment: ${num_compute_nodes}${reset}"
305     DEPLOY_OPTIONS+=" --compute-scale ${num_compute_nodes}"
306   fi
307
308   DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
309
310   DEPLOY_OPTIONS+=" --control-flavor control --compute-flavor compute"
311   if [[ "$virtual" == "TRUE" ]]; then
312      DEPLOY_OPTIONS+=" -e virtual-environment.yaml"
313   fi
314
315   echo -e "${blue}INFO: Deploy options set:\n${DEPLOY_OPTIONS}${reset}"
316
317   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
318 # Create a key for use by nova for live migration
319 echo "Creating nova SSH key for nova resize support"
320 ssh-keygen -f nova_id_rsa -b 1024 -P ""
321 public_key=\'\$(cat nova_id_rsa.pub | cut -d ' ' -f 2)\'
322 sed -i "s#replace_public_key:#key: \$public_key#g" ${ENV_FILE}
323 python -c 'open("opnfv-environment-new.yaml", "w").write((open("${ENV_FILE}").read().replace("replace_private_key:", "key: \"" + "".join(open("nova_id_rsa").readlines()).replace("\\n","\\\n") + "\"")))'
324 mv -f opnfv-environment-new.yaml ${ENV_FILE}
325
326 source stackrc
327 set -o errexit
328 # Workaround for APEX-207 where sometimes swift proxy is down
329 if ! sudo systemctl status openstack-swift-proxy > /dev/null; then
330   sudo systemctl restart openstack-swift-proxy
331 fi
332 echo "Uploading overcloud glance images"
333 openstack overcloud image upload
334
335 echo "Configuring undercloud and discovering nodes"
336 openstack baremetal import --json instackenv.json
337
338 if [[ -z "$virtual" ]]; then
339   openstack baremetal introspection bulk start
340   if [[ -n "$root_disk_list" ]]; then
341     openstack baremetal configure boot --root-device=${root_disk_list}
342   else
343     openstack baremetal configure boot
344   fi
345 else
346   openstack baremetal configure boot
347 fi
348
349 echo "Configuring flavors"
350 for flavor in baremetal control compute; do
351   echo -e "${blue}INFO: Updating flavor: \${flavor}${reset}"
352   if openstack flavor list | grep \${flavor}; then
353     openstack flavor delete \${flavor}
354   fi
355   openstack flavor create --id auto --ram 4096 --disk 39 --vcpus 1 \${flavor}
356   if ! openstack flavor list | grep \${flavor}; then
357     echo -e "${red}ERROR: Unable to create flavor \${flavor}${reset}"
358   fi
359 done
360 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" baremetal
361 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="control" control
362 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="compute" compute
363 echo "Configuring nameserver on ctlplane network"
364 dns_server_ext=''
365 for dns_server in ${dns_servers}; do
366   dns_server_ext="\${dns_server_ext} --dns-nameserver \${dns_server}"
367 done
368 neutron subnet-update \$(neutron subnet-list | grep -Ev "id|tenant|external|storage" | grep -v \\\\-\\\\- | awk {'print \$2'}) \${dns_server_ext}
369 sed -i '/CloudDomain:/c\  CloudDomain: '${domain_name} ${ENV_FILE}
370 echo "Executing overcloud deployment, this should run for an extended period without output."
371 sleep 60 #wait for Hypervisor stats to check-in to nova
372 # save deploy command so it can be used for debugging
373 cat > deploy_command << EOF
374 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
375 EOF
376 EOI
377
378   if [ "$interactive" == "TRUE" ]; then
379     if ! prompt_user "Overcloud Deployment"; then
380       echo -e "${blue}INFO: User requests exit${reset}"
381       exit 0
382     fi
383   fi
384
385   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
386 source stackrc
387 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
388 if ! openstack stack list | grep CREATE_COMPLETE 1>/dev/null; then
389   $(typeset -f debug_stack)
390   debug_stack
391   exit 1
392 fi
393 EOI
394
395   # Configure DPDK and restart ovs agent after bringing up br-phy
396   if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
397     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI || (echo "DPDK config failed, exiting..."; exit 1)
398 source stackrc
399 set -o errexit
400 for node in \$(nova list | grep novacompute | grep -Eo "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+"); do
401 echo "Checking DPDK status and bringing up br-phy on \$node"
402 ssh -T ${SSH_OPTIONS[@]} "heat-admin@\$node" <<EOF
403 set -o errexit
404 sudo dpdk-devbind -s
405 sudo ifup br-phy
406 if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
407   echo "Restarting openvswitch agent to pick up VXLAN tunneling"
408   sudo systemctl restart neutron-openvswitch-agent
409 fi
410 EOF
411 done
412 EOI
413   fi
414
415   if [ "$debug" == 'TRUE' ]; then
416       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
417 source overcloudrc
418 echo "Keystone Endpoint List:"
419 openstack endpoint list
420 echo "Keystone Service List"
421 openstack service list
422 EOI
423   fi
424 }